/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 250
#ifdef HAVE_CONFIG_H
#line 250
# include <config.h>
#line 250
#endif
#line 250
#include <sys/types.h>
#line 250

#line 250
#include "mailfromd.h"
#line 250
#include "prog.h"
#line 250
#include "builtin.h"
#line 250

#line 90 "mbox.bi"
static mu_debug_handle_t debug_handle;
#line 250 "mbox.bi"

#line 767 "../../src/builtin/snarf.m4"

#line 1 "mbox.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008, 2010-2011, 2015-2016 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"
#include "global.h"

static size_t nmboxes = MAX_MBOXES;

static struct mu_cfg_param mbox_cfg_param[] = {
	{ "max-open-mailboxes", mu_cfg_size, &nmboxes, 0, NULL,
	  N_("Maximum number of mailboxes to open simultaneously.") },
	{ NULL }
};

static int
do_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

static void
close_mbox(struct mf_mbox *mp)
{
	if (mp->mbox) {
		mu_mailbox_close(mp->mbox);
		mu_mailbox_destroy(&mp->mbox);
		mu_list_foreach(mp->msglist, do_close, NULL);
		mu_list_destroy(&mp->msglist);
		memset(mp, 0, sizeof mp[0]);
	}
}

static void *
alloc_mboxes()
{
	return mu_calloc(nmboxes, sizeof(struct mf_mbox));
}

static void
destroy_mboxes(void *data)
{
	struct mf_mbox *mtab = data;
	struct mf_mbox *p;
	for (p = mtab; p < mtab + nmboxes; p++) {
		close_mbox(p);
	}
	free(mtab);
}


#line 64

#line 64
static int MBOXTAB_id;
#line 64 "mbox.bi"


static int
find_slot(struct mf_mbox *tab)
{
	int i;
	for (i = 0; i < nmboxes; i++)
		if (tab[i].mbox == NULL)
			return i;
	return -1;
}

/* number mailbox_open(string url) */
void
#line 77
bi_mailbox_open(eval_environ_t env)
#line 77

#line 77

#line 77 "mbox.bi"
{
#line 77
	
#line 77

#line 77
long __bi_argcnt;
#line 77
char *  url;
#line 77
        char *  mode;
#line 77
        char *  perms;
#line 77
        
#line 77
get_string_arg(env, 1, &url);
#line 77
        get_string_arg(env, 2, &mode);
#line 77
        get_string_arg(env, 3, &perms);
#line 77
        
#line 77
get_numeric_arg(env, 0, &__bi_argcnt);
#line 77
        adjust_stack(env, __bi_argcnt + 1);
#line 77

#line 77

#line 77
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 77
		prog_trace(env, "mailbox_open %s %s %s",url, ((__bi_argcnt > 1) ? mode : ""), ((__bi_argcnt > 2) ? perms : ""));;
#line 77

{
	int rc;
	int md;
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
	struct mf_mbox *mp;
	int flags;
	char *p;

	md = find_slot(mbtab);
		if (!(md >= 0))
#line 87
		(
#line 87
	env_throw_bi(env, mfe_failure, "mailbox_open", _("no more mailboxes available"))
#line 87
)
#line 89
;
	
#line 90 "mbox.bi"

#line 90
mu_debug(debug_handle, 10,("opening mailbox %s", url));
	mp = mbtab + md;

	flags = 0;
	for (p = ((__bi_argcnt > 1) ? mode : "r"); *p; p++) {
		switch (*p) {
		case 'a':
			flags |= MU_STREAM_APPEND;
			break;
			
		case 'r':
			flags |= MU_STREAM_READ;
			break;
			
		case 'w':
			flags |= MU_STREAM_WRITE;
			break;
			
		case '+':
			if (flags & MU_STREAM_READ)
				flags |= MU_STREAM_WRITE;
			else if (flags & MU_STREAM_WRITE)
				/* FIXME: should truncate as well */
				flags |= MU_STREAM_READ|MU_STREAM_CREAT;
			else if (flags & MU_STREAM_APPEND) {
				flags |= MU_STREAM_RDWR | MU_STREAM_CREAT;
			} else
				(
#line 117
	env_throw_bi(env, mfe_range, "mailbox_open", _("incorrect mode near `%s'"),p)
#line 117
);
#line 120
			break;

		default:
			(
#line 123
	env_throw_bi(env, mfe_range, "mailbox_open", _("incorrect mode near `%s'"),p)
#line 123
);
#line 126
		}
	}

	/* FIXME: MU: This is ridiculous! */
	if ((flags & (MU_STREAM_READ|MU_STREAM_WRITE))
	    == (MU_STREAM_READ|MU_STREAM_WRITE)) {
		    flags &= ~(MU_STREAM_READ|MU_STREAM_WRITE);
		    flags |= MU_STREAM_RDWR;
	}
	    
	if ((__bi_argcnt > 2)) {
		/* If MU_STREAM_IRGRP is defined, the remaining three
		   permissions flags are defined as well.
		   FIXME: Remove ifdef when MU 2.0 is out. */
#ifdef MU_STREAM_IRGRP
		int f;
		const char *p;
			if (!(mu_parse_stream_perm_string(&f, ((__bi_argcnt > 2) ? perms : 0), &p)
#line 143
			  == 0))
#line 143
		(
#line 143
	env_throw_bi(env, mfe_range, "mailbox_open", /* FIXME: introduce mfe_inval? */
			  _("invalid permissions (near %s)"),p)
#line 143
)
#line 146
;
		flags |= f;
#else
		(
#line 149
	env_throw_bi(env, mfe_failure, "mailbox_open", _("this version of Mailutils does not support "
			   "configurable mailbox permissions"))
#line 149
);
#line 152
#endif
	}
		
	rc = mu_mailbox_create(&mp->mbox, url);
		if (!(rc == 0))
#line 156
		(
#line 156
	env_throw_bi(env, mfe_failure, "mailbox_open", _("cannot create mailbox `%s': %s"),url,mu_strerror(rc))
#line 156
)
#line 159
;
	rc = mu_mailbox_open(mp->mbox, flags);
	if (rc) {
		mu_mailbox_destroy(&mp->mbox);
		(
#line 163
	env_throw_bi(env, mfe_failure, "mailbox_open", _("cannot open mailbox `%s': %s"),url,mu_strerror(rc))
#line 163
);
#line 166
	}
	mu_list_create(&mp->msglist);
	
	
#line 169
do {
#line 169
  push(env, (STKVAL)(mft_number)(md));
#line 169
  goto endlab;
#line 169
} while (0);
}
endlab:
#line 171
        env_function_cleanup_flush(env, NULL);
#line 171
	return;
#line 171
}

/* void mailbox_close(number mbx) */
void
#line 174
bi_mailbox_close(eval_environ_t env)
#line 174

#line 174

#line 174 "mbox.bi"
{
#line 174
	
#line 174

#line 174

#line 174
long  md;
#line 174
        
#line 174
get_numeric_arg(env, 0, &md);
#line 174
        
#line 174

#line 174
        adjust_stack(env, 1);
#line 174

#line 174

#line 174
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 174
		prog_trace(env, "mailbox_close %lu",md);;
#line 174

{
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);

		if (!(md >= 0 && md < nmboxes))
#line 178
		(
#line 178
	env_throw_bi(env, mfe_range, "mailbox_close", _("invalid mailbox descriptor"))
#line 178
)
#line 180
;
	close_mbox(mbtab + md);
}

#line 183
        env_function_cleanup_flush(env, NULL);
#line 183
	return;
#line 183
}

#line 196

	
/* number mailbox_messages_count(number mbx) */
void
#line 199
bi_mailbox_messages_count(eval_environ_t env)
#line 199

#line 199

#line 199 "mbox.bi"
{
#line 199
	
#line 199

#line 199

#line 199
long  nmbx;
#line 199
        
#line 199
get_numeric_arg(env, 0, &nmbx);
#line 199
        
#line 199

#line 199
        adjust_stack(env, 1);
#line 199

#line 199

#line 199
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 199
		prog_trace(env, "mailbox_messages_count %lu",nmbx);;
#line 199

{
	size_t count;
	int rc;
	
#line 203
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 203
	struct mf_mbox *mp;
#line 203
			
#line 203
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 203
		(
#line 203
	env_throw_bi(env, mfe_range, "mailbox_messages_count", _("invalid mailbox descriptor"))
#line 203
)
#line 203
;
#line 203
	mp = mbtab + nmbx;
#line 203
		if (!(mp->mbox))
#line 203
		(
#line 203
	env_throw_bi(env, mfe_failure, "mailbox_messages_count", _("mailbox not open"))
#line 203
)
#line 203

#line 203
;
	
	rc = mu_mailbox_messages_count(mp->mbox, &count);
		if (!(rc == 0))
#line 206
		(
#line 206
	env_throw_bi(env, mfe_failure, "mailbox_messages_count", "%s",mu_strerror(rc))
#line 206
)
#line 209
;
	
#line 210
do {
#line 210
  push(env, (STKVAL)(mft_number)(count));
#line 210
  goto endlab;
#line 210
} while (0);
}
endlab:
#line 212
        env_function_cleanup_flush(env, NULL);
#line 212
	return;
#line 212
}

/* number mailbox_get_message(number mbx, number msg-no) */
void
#line 215
bi_mailbox_get_message(eval_environ_t env)
#line 215

#line 215

#line 215 "mbox.bi"
{
#line 215
	
#line 215

#line 215

#line 215
long  nmbx;
#line 215
        long  msgno;
#line 215
        
#line 215
get_numeric_arg(env, 0, &nmbx);
#line 215
        get_numeric_arg(env, 1, &msgno);
#line 215
        
#line 215

#line 215
        adjust_stack(env, 2);
#line 215

#line 215

#line 215
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 215
		prog_trace(env, "mailbox_get_message %lu %lu",nmbx, msgno);;
#line 215

{
	int rc;
	mu_message_t msg;
	
#line 219
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 219
	struct mf_mbox *mp;
#line 219
			
#line 219
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 219
		(
#line 219
	env_throw_bi(env, mfe_range, "mailbox_get_message", _("invalid mailbox descriptor"))
#line 219
)
#line 219
;
#line 219
	mp = mbtab + nmbx;
#line 219
		if (!(mp->mbox))
#line 219
		(
#line 219
	env_throw_bi(env, mfe_failure, "mailbox_get_message", _("mailbox not open"))
#line 219
)
#line 219

#line 219
;

	rc = mu_mailbox_get_message(mp->mbox, msgno, &msg);
		if (!(rc == 0))
#line 222
		(
#line 222
	env_throw_bi(env, mfe_failure, "mailbox_get_message", "%s",mu_strerror(rc))
#line 222
)
#line 225
;
	rc = bi_message_register(env, mp->msglist, msg, MF_MSG_MAILBOX);
		if (!(rc >= 0))
#line 227
		(
#line 227
	env_throw_bi(env, mfe_failure, "mailbox_get_message", _("no more message slots available"))
#line 227
)
#line 229
;
	
#line 230
do {
#line 230
  push(env, (STKVAL)(mft_number)(rc));
#line 230
  goto endlab;
#line 230
} while (0);
}
endlab:
#line 232
        env_function_cleanup_flush(env, NULL);
#line 232
	return;
#line 232
}

/* void mailbox_append_message(number mbx, number msg-no) */
void
#line 235
bi_mailbox_append_message(eval_environ_t env)
#line 235

#line 235

#line 235 "mbox.bi"
{
#line 235
	
#line 235

#line 235

#line 235
long  nmbx;
#line 235
        long  msgno;
#line 235
        
#line 235
get_numeric_arg(env, 0, &nmbx);
#line 235
        get_numeric_arg(env, 1, &msgno);
#line 235
        
#line 235

#line 235
        adjust_stack(env, 2);
#line 235

#line 235

#line 235
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 235
		prog_trace(env, "mailbox_append_message %lu %lu",nmbx, msgno);;
#line 235

{
	int rc;
	mu_message_t msg;
	
#line 239
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 239
	struct mf_mbox *mp;
#line 239
			
#line 239
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 239
		(
#line 239
	env_throw_bi(env, mfe_range, "mailbox_append_message", _("invalid mailbox descriptor"))
#line 239
)
#line 239
;
#line 239
	mp = mbtab + nmbx;
#line 239
		if (!(mp->mbox))
#line 239
		(
#line 239
	env_throw_bi(env, mfe_failure, "mailbox_append_message", _("mailbox not open"))
#line 239
)
#line 239

#line 239
;

	msg = bi_message_from_descr(env, msgno);
	rc = mu_mailbox_append_message(mp->mbox, msg);
		if (!(rc == 0))
#line 243
		(
#line 243
	env_throw_bi(env, mfe_failure, "mailbox_append_message", _("cannot append message: %s"),mu_strerror(rc))
#line 243
)
#line 246
;
}

#line 248
        env_function_cleanup_flush(env, NULL);
#line 248
	return;
#line 248
}


#line 250
void
#line 250
mbox_init_builtin()
#line 250
{
#line 250
		debug_handle = mu_debug_register_category("bi_mbox");
#line 250

#line 250
	#line 64 "mbox.bi"
MBOXTAB_id = builtin_priv_register(alloc_mboxes, destroy_mboxes,
#line 64
NULL);
#line 77 "mbox.bi"
va_builtin_install_ex("mailbox_open", bi_mailbox_open, 0, dtype_number, 3, 2, 0|0, dtype_string, dtype_string, dtype_string);
#line 174 "mbox.bi"
va_builtin_install_ex("mailbox_close", bi_mailbox_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 199 "mbox.bi"
va_builtin_install_ex("mailbox_messages_count", bi_mailbox_messages_count, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 215 "mbox.bi"
va_builtin_install_ex("mailbox_get_message", bi_mailbox_get_message, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 235 "mbox.bi"
va_builtin_install_ex("mailbox_append_message", bi_mailbox_append_message, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_number);

#line 250 "mbox.bi"
	
#line 250
	 mf_add_runtime_params(mbox_cfg_param);
#line 250
	 
#line 250
}
#line 250 "mbox.bi"

#line 252

#line 761 "../../src/builtin/snarf.m4"

#line 761

